/*
	Standard header file for PROGS SMS C library

	definition of error codes

	(c) PROGS, Professional & Graphical Software
	written by Joachim Van der Auwera, 6 October 1994
*/
typedef enum {
	ERRNone 		  = 0	  , /* no error occured */
	ERRComplete 	  = -1	  , /* operation not complete */
	ERRJob			  = -2	  , /* invalid job id */
	ERRMemory		  = -3	  , /* insufficient memory */
	ERRRange		  = -4	  , /* parameter outside permitted range */
	ERRBuffer		  = -5	  , /* buffer full */
	ERRChannel		  = -6	  , /* invalid channel id */
	ERRNotFound 	  = -7	  , /* file or device or item not found */
	ERRExists		  = -8	  , /* file already exists */
	ERRInUse		  = -9	  , /* file or device in use */
	ERREndOfFile	  = -10   , /* end of file */
	ERRDriveFull	  = -11   , /* drive full */
	ERRName 		  = -12   , /* invalid file, device or thing name */
	ERRTransmission   = -13   , /* transmission error */
	ERRFormat		  = -14   , /* format drive failed */
	ERRParameter	  = -15   , /* invalid parameter */
	ERRMedium		  = -16   , /* file system medium check failed */
	ERRExpression	  = -17   , /* invalid expression */
	ERROverflow 	  = -18   , /* arithmetic overflow */
	ERRImplemented	  = -19   , /* operation not implemented */
	ERRReadOnly 	  = -20   , /* read only permitted */
	ERRSyntax		  = -21   , /* invalid syntax */
	ERRReadWrite	  = -22 	/* read or write failed */
	} Error;
