#ifndef _IO_H
#define _IO_H

/*
	Standard header file for PROGS SMS C library

	File io handling library

	(c) PROGS, Professional & Graphical Software
	written by Joachim Van der Auwera, 19 October 1994
*/

#include "SMS.h"

#define FOREVER (TimeOut)-1
#define NOWAIT (TimeOut)0
typedef short TimeOut;		/* TimeOut value */

/* constants for io library */
#define OPEN_OLD	(OpenKey)0
#define OPEN_READ	(OpenKey)1
#define OPEN_NEW	(OpenKey)2
#define OPEN_OVER	(OpenKey)3
#define OPEN_DIR	(OpenKey)4
#define OPEN_RENAME (OpenKey)5
typedef short OpenKey;		/* key for type of file open */

#define PATH_DATA	  (char *)-1
#define PATH_PROG	  (char *)-2
#define PATH_DATAPROG (char *)-3
#define PATH_PROGDATA (char *)-4

#define TO_END_OF_FILE 0x3fffffff	/* to set/move filepos to end of file */
									/* apparently 1GB is the max file length */

Error IOOpen(char *name, OpenKey key, Channel *id);
Error IOOpenFor(char *name, OpenKey key, Job id, Channel *ret);
Error IOOpenPath(char *name, OpenKey key, char *path, Channel *id);
Error IOOpenPathFor(char *name, OpenKey key, Job id, char *path, Channel *ret);
#define IOOpenPath(n,k,p,c) IOOpenPathFor(n,k,p,MYSELF,c)
Error IOClose(Channel);
Error IOFormat(char *name, int *good, int *total);
Error IODelete(char *name);

Error IOGet(Channel id, char *ret);
Error IOPut(Channel id, char value);
Error IOPutBack(Channel id, char value);
Error IOGetBytes(Channel id, int count, char *place, int *got);
Error IOPutBytes(Channel id, int count, char *bytes, int *sent);
Error IOGetString(Channel id, char *string, int buffsize);
Error IOPutString(Channel id, char *string, int *sent);

Error IOGetFormat(Channel id, const char *, ...);
Error IOPutFormat(Channel id, const char *, ...);

Error IOTest(Channel);
Error IODone(Channel);
Error IOFlush(Channel);
Error IOTruncate(Channel);

Error IOTimeOutSet(Channel id, TimeOut t);
Error IOTimeOutGet(Channel id, TimeOut *t);

Error IOPositionGet(Channel id, int *position);
Error IOPositionSet(Channel id, int position);
Error IOPositionMove(Channel id, int position);

#ifdef NOT_DEFINED_JUST_YET
	IOName
	IOLength
	IOFUpdateDateGet
	IOFUpdateDateSet
	IOFBackupDateGet
	IOFBackupDateSet
	IOFVersionGet
	IOFVersionSet
	IOFileTypeGet
	IOFileTypeSet
	IODataSpaceGet
	IODataSpaceSet


	IOLoadFile
	IOSaveFile
	IORenameFile
	IOMakeDirectory
#endif

#endif _IO_H
