; part of the memory library for the PROGS SMS C library
;   MEMCopy             copy some memory from one place to another
;   MEMClear            clear an area of memory
;   MEMSame             compare two areas of memory; equal->TRUE, else FALSE
;   MEMSearch           search a byte in some memory
;   MEMSwap             swap two areas of memory
; written by Joachim Van der Auwera for PROGS
; (c) 1994 by PROGS, Professional & Graphical Software, all rights reserved
; started 2 November 1994
; 01.11.1996 MEMSwap was very bugged
        section text
        include win1_inc_keys_err
        include win1_inc_aid_mac
;
; offsets for parameters
size    equ     4               ; .l size of object
from    equ     8               ; .l from
area    equ     8
area1   equ     8
to      equ     12              ; .l to
area2   equ     12
;
; copy some memory from one place to another, as fast as possible
_MEMCopy xsub
        moveq   #err.ipar,d0    ; assume bad parameter
        move.l  size(sp),d1     ; number of bytes to copy
        ble.s   cpyend          ; has to be positive !!
        move.l  from(sp),a0     ; from
        move.l  to(sp),a1       ; to
        cmpa.l  a0,a1           ; compare them
        beq.s   cpydone         ; nothing to do
        bhi.s   cprev           ; copy from back to front

        move.l  a0,d0           ; see if both start at even or odd addresses
        move.l  d2,-(sp)        ; keep for a tick
        move.l  a1,d2           ; well euh, eor doesn't like addres regs
        eor.l   d2,d0           ; as this prevents optimisations
        move.l  (sp)+,d2        ; restore
        btst    #0,d0           ; actual test
        beq.s   optcpy          ; yes we can optimise -> ..

coplp   move.b  (a0)+,(a1)+     ; copy a byte
        subq.l  #1,d1           ; another one ??
        bne.s   coplp           ; yes -> do it
        bra.s   cpydone

optcpy  move.l  a0,d0           ; are the addresses even ??
        btst    #0,d0           ; actual test
        beq.s   cpye            ; no -> don't make even
        move.b  (a0)+,(a1)+     ; make even
        subq.l  #1,d1           ; one less byte to go
cpye
        move.l  d1,d0           ; prepare for loop
        lsr.l   #5,d0           ; in steps of thirtytwo
cpyll   subq.l  #1,d0           ; another block ??
        bmi.s   cpyle           ; or not -> ..
        move.l  (a0)+,(a1)+     ; copy another long word
        move.l  (a0)+,(a1)+     ; copy another long word
        move.l  (a0)+,(a1)+     ; copy another long word
        move.l  (a0)+,(a1)+     ; copy another long word
        move.l  (a0)+,(a1)+     ; copy another long word
        move.l  (a0)+,(a1)+     ; copy another long word
        move.l  (a0)+,(a1)+     ; copy another long word
        move.l  (a0)+,(a1)+     ; copy another long word
        bra.s   cpyll           ; go again ..
cpyle   andi.w  #31,d1          ; at most 32 bytes to go
        move.w  d1,d0           ; number of bytes to clear
        lsr.w   #1,d0           ; number of words to clear
        bra.s   cpyse           ; test for another
cpysl   move.w  (a0)+,(a1)+     ; copy another word
cpyse   dbf     d0,cpysl        ; another one ??
        btst    #0,d1           ; clear an extra byte ??
        beq.s   cpydone         ; no -> don't
        move.b  (a0)+,(a1)+     ; copy last byte
cpydone moveq   #0,d0           ; no errors
cpyend  subend
; copy from back to front to make it safe for overlapping regions
cprev
        add.l   d1,a0           ; end of area to copy from
        add.l   d1,a1           ; end of area to copy to
        move.l  a0,d0           ; see if both start at even or odd addresses
        move.l  d2,-(sp)        ; keep for a tick
        move.l  a1,d2           ; well euh, eor doesn't like addres regs
        eor.l   d2,d0           ; as this prevents optimisations
        move.l  (sp)+,d2        ; restore
        btst    #0,d0           ; actual test
        beq.s   roptcpy         ; yes we can optimise -> ..

rcoplp  move.b  -(a0),-(a1)     ; copy a byte
        subq.l  #1,d1           ; another one ??
        bne.s   rcoplp          ; yes -> do it
        bra     cpydone

roptcpy move.l  a0,d0           ; are the addresses even ??
        btst    #0,d0           ; actual test
        beq.s   rcpye           ; no -> don't make even
        move.b  -(a0),-(a1)     ; make even
        subq.l  #1,d1           ; one less byte to go
rcpye
        move.l  d1,d0           ; prepare for loop
        lsr.l   #5,d0           ; in steps of thirtytwo
rcpyll  subq.l  #1,d0           ; another block ??
        bmi.s   rcpyle          ; or not -> ..
        move.l  -(a0),-(a1)     ; copy another long word
        move.l  -(a0),-(a1)     ; copy another long word
        move.l  -(a0),-(a1)     ; copy another long word
        move.l  -(a0),-(a1)     ; copy another long word
        move.l  -(a0),-(a1)     ; copy another long word
        move.l  -(a0),-(a1)     ; copy another long word
        move.l  -(a0),-(a1)     ; copy another long word
        move.l  -(a0),-(a1)     ; copy another long word
        bra.s   rcpyll          ; go again ..
rcpyle  andi.w  #31,d1          ; at most 32 bytes to go
        move.w  d1,d0           ; number of bytes to clear
        lsr.w   #1,d0           ; number of words to clear
        bra.s   rcpyse          ; test for another
rcpysl  move.w  -(a0),-(a1)     ; copy another word
rcpyse  dbf     d0,rcpysl       ; another one ??
        btst    #0,d1           ; clear an extra byte ??
        beq.s   cpydone         ; no -> don't
        move.b  -(a0),-(a1)     ; copy last byte
        bra     cpydone
;
; clear an area of memory, as fast as possible
_MEMClear xsub
        moveq   #err.ipar,d0
        move.l  size(sp),d1     ; number of bytes to copy
        ble.s   clrend
        move.l  area(sp),a0     ; base
        move.l  a0,d0           ; base of area
        btst    #0,d0           ; at an even address ??
        beq.s   clrl            ; yes -> continue on even addresses
        subq.l  #1,d1           ; one byte less to clear
        clr.b   (a0)+           ; done
clrl    move.l  d1,d0           ; prepare for loop
        lsr.l   #5,d0           ; in steps of thirtytwo
clrll   subq.l  #1,d0           ; another block ??
        bmi.s   clrle           ; or not -> ..
        clr.l   (a0)+           ; clear another long word
        clr.l   (a0)+           ; clear another long word
        clr.l   (a0)+           ; clear another long word
        clr.l   (a0)+           ; clear another long word
        clr.l   (a0)+           ; clear another long word
        clr.l   (a0)+           ; clear another long word
        clr.l   (a0)+           ; clear another long word
        clr.l   (a0)+           ; clear another long word
        bra.s   clrll           ; go again ..
clrle   andi.w  #31,d1          ; at most 32 bytes to go
        move.w  d1,d0           ; number of bytes to clear
        lsr.w   #1,d0           ; number of words to clear
        bra.s   clrse           ; test for another
clrsl   clr.w   (a0)+           ; clear another word
clrse   dbf     d0,clrsl        ; another one ??
        btst    #0,d1           ; clear an extra byte ??
        beq.s   clrdone         ; no -> don't
        clr.b   (a0)+           ; clear last byte
clrdone moveq   #0,d0           ; no errors, of course
clrend  subend
;
; compare two areas of memory, as fast as possible
; equal->TRUE, else FALSE
_MEMSame xsub
        move.l  size(sp),d1     ; number of bytes to copy
        ble.s   samsame
        move.l  area1(sp),a0    ; area1
        move.l  area2(sp),a1    ; area2

        move.l  a0,d0           ; see if both start at even or odd addresses
        move.l  d2,-(sp)        ; keep for a tick
        move.l  a1,d2           ; well euh, eor doesn't like addres regs
        eor.l   d2,d0           ; as this prevents optimisations
        move.l  (sp)+,d2        ; restore
        btst    #0,d0           ; actual test
        beq.s   optsam          ; yes we can optimise -> ..

samlp   cmp.b   (a0)+,(a1)+     ; compare a byte
        bne.s   samdiff         ; oops, different
        subq.l  #1,d1           ; another one ??
        bne.s   samlp           ; yes -> do it
        bra.s   samsame         ; equal -> TRUE and end

optsam  move.l  a0,d0           ; are the addresses even ??
        btst    #0,d0           ; actual test
        beq.s   same            ; no -> don't make even
        cmp.b   (a0)+,(a1)+     ; make even
        bne.s   samdiff         ; oops, different
        subq.l  #1,d1           ; one less byte to go
same
        move.l  d1,d0           ; prepare for loop
        lsr.l   #2,d0           ; in steps of four
samll   subq.l  #1,d0           ; another block ??
        bmi.s   samle           ; or not -> ..
        cmp.l   (a0)+,(a1)+     ; compare another long word
        bne.s   samdiff         ; oops, different
        bra.s   samll           ; go again ..
samle   btst    #1,d1           ; compare an extra word ??
        beq.s   samwe           ; no -> don't
        cmp.w   (a0)+,(a1)+     ; compare another word
        bne.s   samdiff         ; oops, different
samwe   btst    #0,d1           ; compare an extra byte ??
        beq.s   samsame         ; no -> don't
        cmp.b   (a0)+,(a1)+     ; compare last byte
        beq.s   samsame         ; equal -> TRUE
samdiff moveq   #0,d0           ; different -> FALSE
        subend
samsame moveq   #-1,d0          ; same -> TRUE
        subend
;
; search a byte in some memory
byte    equ     4               ; .w byte we want to search
len     equ     6               ; .l length of area
base    equ     10              ; .l base of area to search
at      equ     14              ; position of match
_MEMSearch xsub
        move.w  byte(sp),d0     ; byte to find
        move.l  len(sp),d1      ; amount to search
        move.l  base(sp),a0     ; base of area
        move.l  at(sp),a1       ; position of match
        clr.l   (a1)            ; assume no match
loop    subq.l  #1,d1           ; one more ??
        bmi.s   nomatch         ; no -> end
        cmp.b   (a0)+,d0        ; compare
        bne.s   loop            ; no match -> try again
        moveq   #0,d0           ; no error
        subq.l  #1,a0           ; undo auto increment
        move.l  a0,(a1)         ; place of match
        bra.s   seaend
nomatch moveq   #err.itnf,d0    ; not found
seaend  subend
;
; swap the contents of two areas of memory
_MEMSwap xsub
        move.l  area1(sp),a0
        move.l  area2(sp),a1
        move.l  a0,d0
        move.l  a1,d1
        or.l    d0,d1
        move.l  size(sp),d0
        beq.s   swapdone
        btst    #0,d1           ; both at even addresses ??
        beq.s   swapfast
swaplp1 move.b  (a0),d1
        move.b  (a1),(a0)+
        move.b  d1,(a1)+
        subq.l  #1,d0
        bne.s   swaplp1
        bra.s   swapdone
swapfast
        lsr.l   #2,d0           ; divide number of bytes to copy by four
        beq.s   swaprem
swaplp2 move.l  (a0),d1
        move.l  (a1),(a0)+
        move.l  d1,(a1)+
        subq.l  #1,d0
        bne.s   swaplp2
swaprem move.l  size(sp),d0
        btst    #1,d0           ; swap another word ??
        beq.s   swapbyt
        move.w  (a0),d1
        move.w  (a1),(a0)+
        move.w  d1,(a1)+
swapbyt btst    #0,d0           ; swap another word ??
        beq.s   swapdone
        move.b  (a0),d1
        move.b  (a1),(a0)+
        move.b  d1,(a1)+
swapdone moveq  #0,d0
        subend
;
        end
