; MUTEX library for the PROGS SMS C library
;   MUTEXCall           call a routine using mutual exclusion over a char
; written by Joachim Van der Auwera for PROGS
; (c) 1994 by PROGS, Professional & Graphical Software, all rights reserved
; started 1 December 1994
; 29.06.1996 MUTEXCall lost the parameters when waiting
        section text
        include win1_inc_aid_mac
;
; call a routine in an atomic way
mutex   equ     4               ; .l mutex descriptor
rout    equ     8               ; .l first parameter, routine to call
count   equ     12              ; .l second parameter, parameter count
_MUTEXCall xsub
        regsave d2/d3/d4/a2/a3
        lea     20+mutex(sp),a1 ; place with the parameters
        move.l  (a1)+,a2        ; mutex descriptor
        move.l  (a2),a3         ; mutex character
        move.l  (a1)+,a0        ; routine to call
        move.l  (a1)+,d3        ; number of parameters
GrabMutex
        move.w  sr,d4           ; keep old status register
        trap    #0              ; move into supervisor mode
        tas     (a3)            ; see if mutex character is free
        bne.s   SusJob          ; no -> suspend and try again
        move.l  a1,d2           ; just save a1 for a second
        lea     release(pc),a1
        move.l  a1,-4(a2)       ; ZapRoutine in case of rjob
        move.l  d2,a1           ; restore a1 again
        move.w  d4,sr           ; restore status register

        move.l  d3,d2           ; need copy of count
        lsl.w   #2,d3           ; number of bytes
        beq.s   none            ; nothing to copy
        adda.w  d3,a1           ; last parameter
        subq.w  #1,d2           ; adjust for dbf
copy    move.l  -(a1),-(sp)     ; copy a parameter
        dbf     d2,copy         ; another ??
none
        jsr     (a0)            ; call routine in an atomic way
        add.l   d3,sp           ; restore stack

        move.w  sr,d4           ; keep old status register
        trap    #0              ; move into supervisor mode
        clr.b   (a3)            ; release mutex character
        clr.l   -4(a2)          ; clear ZapRoutine in case of rjob
        move.w  d4,sr           ; restore status register

        subend
;
SusJob  move.w  d4,sr           ; restore status register
        movem.l a0/a1/d3,-(sp)
        moveq   #8,d0           ; suspend
        moveq   #-1,d1          ; myself
        moveq   #1,d3           ; for a tick
        sub.l   a1,a1           ; without flag byte
        trap    #1              ; do it - cause rescheduling (fortunately)
        movem.l (sp)+,a0/a1/d3
        bra     GrabMutex
;
release move.l  4(sp),a0        ; base of memory
        move.l  (a0),a1         ; mutex character
        clr.b   (a1)            ; clear mutex character, this is safe because
                                ; this routine is called in supervisor mode
        move.l  4(a0),d0        ; is there a cleanup routine ??
        bne.s   rdone           ; no -> done
        move.l  d0,a0           ; base of routine
        jmp     (a0)            ; call cleanup routine
rdone   rts
;
        end
