; SMS library for the PROGS SMS C library
;   SMSVersion          get the version of the operatin system
;   SMSBaud             set the baud rate for the serial ports
;   SMSBeep             simple sound generation, only duration and pitch
;   _MessagePtr         get the message ptr for an error
;   SMSBreakSoft        create a soft breakpoint (Trap #15)
;   SMSBreakHard        create a hard breakpoint ( $4afb edeb)
; written by Joachim Van der Auwera for PROGS
; (c) 1994 by PROGS, Professional & Graphical Software, all rights reserved
; started 23 November 1994
; 11.11.1995 SMSBeep fixed (duration ok) + slight code reduction
        section text
        include win1_inc_qdos_sms
        include win1_inc_keys_err
        include win1_inc_keys_sys
        include win1_inc_aid_mac
;
; routines to get the current system default
string  equ     4               ; string to store result
_SMSVersion xsub
devget  move.l  string(sp),a1   ; place to fill in return value
        moveq   #sms.info,d0    ; get system info
        trap    #do.sms2        ; do it
        move.l  d2,(a1)         ; set version string
        clr.b   4(a1)           ; with eos marker
        subend
;
; set the baud rate
rate    equ     4               ; .w baud rate
_SMSBaud xsub
        move.w  rate(sp),d1     ; new baud rate
        moveq   #sms.comm,d0    ; set communication baud rate
        trap    #do.sms2        ; do it
        subend
;
; beep
time    equ     4               ; .w duration
pitch   equ     6               ; .b pitch
_SMSBeep xsub
        move.w  time(sp),d0     ; byte swap duration
        rol.w   #8,d0
        move.w  pitch(sp),d1
        regsave d5/d7/a3
        getssp  16
        move.l  sp,a3
        move.w  #$a08,(a3)      ; command and no of params
        move.l  #$aaaa,2(a3)    ; amount for each parameter
        clr.l   6(a3)           ; no pitch2,interval
        move.b  d1,6(a3)        ; pitch1
        move.w  d0,10(a3)       ; duration
        clr.w   12(a3)          ; step, wrap, randomness, fuziness
        move.b  #1,14(a3)       ; no return
        moveq   #sms.hdop,d0    ; do hardware dependent operation
        trap    #do.sms2        ; do it
        subend
;
error   equ     4               ; .l error
message equ     8               ; .l message ptr
__MessagePtr xsub
        move.l  error(sp),a1
        moveq   #sms.mptr,d0
        trap    #do.sms2
        tst.l   d0
        bne.s   emptr
        move.l  8(sp),a0
        move.l  a1,(a0)
emptr   subend
;
; create a soft breakpoint (Trap #15)
_SMSBreakSoft xsub
        trap    #15
        subend
;
; create a hard breakpoint ( $4afb edeb)
_SMSBreakHard xsub
        dc.w    $4afb,$edeb
        subend
;
        end
