#ifndef _SYSLIB_DIR_H
#define _SYSLIB_DIR_H

/*
	Standard header file for PROGS SMS C library

	Directory handling library

	(c) PROGS, Professional & Graphical Software
	written by Joachim Van der Auwera, 6 August 1995
*/

#include "io_h"

typedef long DirIterator;	/* external representation of Directory Iterator */

Error DIROpen(char *directory, char tree, DirIterator *iterator, ...);
Error DIRDirectory(DirIterator iterator, char *directory);
Error DIRNext(DirIterator iterator, FileInfo *result);
Error DIRClose(DirIterator iterator);
	/* The DIROpen call accepts a NULL terminated list of pairs */
	/*	Error (*sieve)(FileInfo *file, int parameter), parameter */
	/* The sieve routines are called from left to right on each file in the */
	/* directory until one returns an error. A file is only filled in into */
	/* the result structure of a DIRNext call if it is accepted (no error) */
	/* by all the sieve routines. */
	/* When tree is TRUE, the entire tree will be scanned, otherwise only */
	/* the files in the requested directory are scanned (and no subdirs) */

Error DIRSubOpen(char *directory, char tree, DirIterator *iterator);
Error DIRSubDirectory(DirIterator iterator, char *directory);
#define DIRSubDirectory(i,d) DIRDirectory(i,d)
Error DIRSubNext(DirIterator iterator, FileInfo *result);
#define DIRSubNext(i,r) DIRNext(i,r)
Error DIRSubClose(DirIterator iterator);
#define DIRSubClose(i) DIRClose(i)
	/* For DIRSubNext only the name field should be used */

Error DIRSieveLength(FileInfo *file, int parameter);
Error DIRSieveLengthLarger(FileInfo *file, int parameter);
Error DIRSieveLengthSmaller(FileInfo *file, int parameter);
Error DIRSieveType(FileInfo *file, int parameter);
Error DIRSieveExtension(FileInfo *file, int parameter);
Error DIRSieveExtensionNot(FileInfo *file, int parameter);

#endif _SYSLIB_DIR_H
