; Dynamic Link Library Manager
; written by Joachim Van der Auwera for PROGS
; (c) 1994 PROGS, Professional & Graphical Software
; started 8 October 1994
        section text
;
        include win1_inc_keys_err
        include win1_inc_keys_thg
        include win1_inc_qdos_sms
        include win1_inc_qdos_io
        include win1_inc_qdos_ioa
        include win1_inc_keys_qlv
;
        xdef    thg_head
;
        xref    relocate,link
        xref    THINGcall,thg_name
;
; definition of DLLLinkage structure, use to identify module details
base            equ     0       ; offset for this structure from program start
init            equ     4       ; offset of init routine from program base
bss             equ     8       ; offset of BSS area from program base
;
; definitions of DLLEntry structure
identifier      equ     0       ; value "<<QDLL>>"
usercode        equ     8       ; position of usercode
extension       equ     12      ; extension to use
thingname       equ     16      ; name of thing to use
;
; definition of size of executable header
exec.len        equ     6+2+2+64
;
window  dc.b    0,1,2,7         ; colours
        dc.w    350,40,85,80    ; coordinates
mess1   dc.w    11,'can''t find '
mess2   dc.w    12,' library in '
mess3   dc.b    0,12,10,'press a key'
;
; nu komt de thing header
; daarvoor definieren we eerst enkele macro's
label   setnum  0
exte    macro   naam
ext[label]
        dc.l    thh.flag        ; flag signalling standard header
        dc.l    $01000003       ; type of thing
lablp   setstr  ext[label]
label   setnum  [label]+1
        dc.l    ext[label]-[lablp]      ; offset to next thing in list
        dc.l    '[naam]'        ; extra ID
        dc.l    0               ; offset to parameter description
        dc.l    0               ; offset to description
        endm

last     macro   naam
ext[label]
        dc.l    thh.flag        ; flag signalling standard header
        dc.l    $00000003       ; type of thing
        dc.l    0               ; this is the last one
        dc.l    '[naam]'        ; extra ID
        dc.l    0               ; offset to parameter description
        dc.l    0               ; offset to description
        endm


; The only difference between EXEC, REXT and cod_LINK is what to to at the end
; both have to do program relocation and linking of DLL's
; COD_LINK then has to return the address of the init function (or structure)
; EXEC has to pass the command line parameters and call init
; REXT just has to call the init routine
; LINK only has to link in the DLL's
;
; EXEC also has to be able to handle the case when a job is loaded as resident
; extension. This has to be detected. When it is loaded as resident extension,
; then the relocation can already be done. The dynamic linking should only be
; done when the thing is actually executed (to make sure the dependencies are
; correct).
thg_head
        exte    EXEC            ; entry point for executables
; on entry the stack contains (addresses increase by length indicated)
;   no return address !!                    (0)
;   address of DLLLinkage structure         (.l)
;   number of chid's passed                 (.w)
;   list of chid's                          (.l*number)
;   length of argument string               (.w)
;   argument string, not zero-terminated    (.b*length)
; it is not necessary to keep using this thing, so release it
        lea     thg_name(pc),a0 ; name of thing to release
        moveq   #sms.fthg,d0    ; free thing
        moveq   #sms.myjb,d1    ; for myself
        bsr     THINGcall       ; do it
; test whether the code is loaded as resident extension
        moveq   #myself,d1      ; info about myself
        moveq   #myself,d2      ; I am also at the top of the tree
        moveq   #sms.injb,d0    ; get info about job
        trap    #do.sms2        ; do it
        move.l  (sp),a1         ; DLLLinkage structure
        suba.l  base(a1),a1     ; start of program
        moveq   #exec.len,d0    ; length of program header (program name etc)
        move.l  a1,d1
        sub.l   d0,d1
        move.l  d1,a5
        cmpa.l  a0,a5
        beq.s   doexec
        ; if there is no exact match than the program may still have been
        ; executed if the addresses are somewhat "in range"
        bhi.s   thgtst
        add.l   d0,d1
        cmp.l   a0,d1
        bhi.s   doexec
thgtst  tst.l   2(a5)           ; see if it was already linked
        bne     exthg
doexec
; do program relocation and dynamic linking
        bsr     relocate
        bsr     link
        beq.s   exlinkok
; oops, dynamic linking failed, we should report the problem and exit
        move.l  a0,a4           ; DLLEntry
        move.w  opw.con,a0      ; set up a console
        lea     window(pc),a1   ; useing these parameters
        jsr     (a0)            ; do it
        tst.l   d0              ; success ??
        bne.s   kill            ; oops
        moveq   #forever,d3     ; timeout
        lea     mess1(pc),a1    ; message
        move.w  (a1)+,d2        ; length of string
        moveq   #iob.smul,d0
        trap    #do.io
        lea     extension(a4),a1; message
        moveq   #4,d2           ; length of string
        moveq   #iob.smul,d0
        trap    #do.io
        lea     mess2(pc),a1    ; message
        move.w  (a1)+,d2        ; length of string
        moveq   #iob.smul,d0
        trap    #do.io
        lea     thingname(a4),a1; message
        move.w  (a1)+,d2        ; length of string
        moveq   #iob.smul,d0
        trap    #do.io
        lea     mess3(pc),a1    ; message
        move.w  (a1)+,d2        ; length of string
        moveq   #iob.smul,d0
        trap    #do.io
        moveq   #iow.ecur,d0    ; enable cursor
        trap    #do.io
        moveq   #iob.fbyt,d0    ; fetch a byte
        trap    #do.io
        bra.s   kill            ; kill this job
exlinkok
; we assume enough dataspace is allocated for the entire program
; pass the command line parameters
        move.w  4(sp),d0        ; get number of chid's on stack
        lea     6(sp),a0        ; base of array with chid's
        move.l  a0,-(sp)        ; base of array with chid's
        move.w  d0,-(sp)        ; number of channels
        add.w   d0,d0           ; get length of area with chid's
        add.w   d0,d0
        lea     0(a0,d0.w),a0   ; base of command string (QL string)
        move.w  (a0)+,d0        ; length of string
        clr.b   (a0,d0.w)       ; make sure there is an ending zero !
        move.l  a0,-(sp)        ; base of argument string
; call the init routine
        move.l  10(sp),a0       ; base of DLLLinkage structure
        move.l  a0,a1           ; copy for calculations
        sub.l   base(a0),a1     ; make that program base
        add.l   init(a0),a1     ; make that address of init
        jsr     (a1)            ; start the program
; and remove the job
kill    move.l  d0,d3           ; error to return
        moveq   #sms.frjb,d0    ; remove
        moveq   #sms.myjb,d1    ; myself
        trap    #do.sms2        ; do it
                                ; and we won't get this far

; code to link in as an executable thing
; the program name is now in 8(a0) (as QDOS string)
exthg   lea     8(a5),a4        ; start of program name - future thing name

        moveq   #th.len+thh.len,d1
        add.w   (a4),d1         ; amount of memory for thing linkage
        moveq   #sms.achp,d0    ; reserve memory
        moveq   #0,d2           ; for the system
        trap    #do.sms2        ; do it
        tst.l   d0
        bne.s   extexit
                                ; a0 is start of thing
        lea     th_name(a0),a1  ; start of thing name
        move.w  (a4)+,d0        ; name length
        move.w  d0,(a1)+        ; fill in
        addq.w  #1,d0
        lsr.w   #1,d0
        bra.s   extcope         ; do the copy
extcopy move.w  (a4)+,(a1)+
extcope dbf     d0,extcopy
                                ; a1 now start of actual thing
        move.l  a1,th_thing(a0) ; pointer to start of thing
        move.l  #thh.flag,thh_flag(a1)
        move.l  #tht.exec,thh_type(a1)
        move.l  a5,d0
        sub.l   a1,d0
        move.l  d0,thh_hdrs(a1)
        moveq   #exec.len,d0
        move.l  d0,thh_hdrl(a1)
        move.l  2(a5),thh_data(a1)
        move.l  a5,d0
        sub.l   a1,d0
        move.l  d0,thh_strt(a1)
        clr.l   2(a5)           ; mark that the thing is linked
        move.l  a0,a1           ; address of thing linkage
        moveq   #sms.lthg,d0    ; Link in new Thing
        bsr     THINGcall       ; do it
        bne.s   extexit

        bsr     relocate
        moveq   #0,d0
extexit addq.l  #4,sp           ; remove DLLLinkage from stack
        rts

; code to link in a resident extension
        exte    REXT
; on entry the stack contains (addresses increase by length indicated)
;   no return address !!                    (0)
;   address of DLLLinkage structure         (.l)
; it is not necessary to keep using this thing, so release it
        lea     thg_name(pc),a0 ; name of thing to release
        moveq   #sms.fthg,d0    ; free thing
        moveq   #sms.myjb,d1    ; for myself
        bsr     THINGcall       ; do it
; do program relocation and dynamic linking
        bsr     relocate
        bsr     link
        beq.s   rxlinkok
; oops, dynamic linking failed, we should report the problem and exit
        addq.l  #4,sp           ; remove address of DLLLinkage from stack
        move.l  a0,a4           ; DLLEntry
        sub.l   a0,a0           ; send to channel zero
        moveq   #forever,d3     ; timeout
        lea     mess1(pc),a1    ; message
        move.w  (a1)+,d2        ; length of string
        moveq   #iob.smul,d0
        trap    #do.io
        lea     extension(a4),a1; message
        moveq   #4,d2           ; length of string
        moveq   #iob.smul,d0
        trap    #do.io
        lea     mess2(pc),a1    ; message
        move.w  (a1)+,d2        ; length of string
        moveq   #iob.smul,d0
        trap    #do.io
        lea     thingname(a4),a1; message
        move.w  (a1)+,d2        ; length of string
        moveq   #iob.smul,d0
        trap    #do.io
        moveq   #10,d1          ; add a newline
        moveq   #iob.sbyt,d0    ; fetch a byte
        trap    #do.io
        moveq   #err.itnf,d0    ; not found error
        rts                     ; return
rxlinkok
; call the init routine
        move.l  (sp)+,a0        ; base of DLLLinkage structure
        move.l  a0,a1           ; copy for calculations
        sub.l   base(a0),a1     ; make that program base
        add.l   init(a0),a1     ; make that address of init
        jmp     (a1)            ; start the program

; code to link in all the DLL's in a program
        exte    LINK
; on entry the stack contains (addresses increase by length indicated)
;   return address                          (.l)
;   address of DLLLinkage structure         (.l)
; it is not necessary to keep using this thing, so release it
        lea     thg_name(pc),a0 ; name of thing to release
        moveq   #sms.fthg,d0    ; free thing
        moveq   #sms.myjb,d1    ; for myself
        bsr     THINGcall       ; do it
; do dynamic linking
        jmp     link

        exte    {ASM }
        lea     thg_name(pc),a0 ; name of thing to release
        moveq   #sms.fthg,d0    ; free thing
        moveq   #sms.myjb,d1    ; for myself
        bsr     THINGcall       ; do it
        move.l  4(sp),-(sp)
        bsr     relocate
        addq.l  #4,sp
        jmp     link

cod_LINK
; on entry the stack contains (addresses increase by length indicated)
;   return address                          (.l)
;   address of DLLLinkage structure         (.l)
        move.l  4(sp),-(sp)     ; make sure the parameter is where expected
        bsr     relocate
        bsr     link
        addq.l  #4,sp           ; clean up
        beq.s   lnlinkok
; oops, dynamic linking failed, we should report the problem
        moveq   #0,d0           ; no init - this indicates the error
        rts                     ; return
lnlinkok
        move.l  4(sp),a0        ; base of DLLLinkage structure
        move.l  a0,d0           ; as return value
        sub.l   base(a0),d0     ; make that program base
        add.l   init(a0),d0     ; make that address of init
        rts

; cod_LINK has to fill in the usercode for the seperate module handler
        last    EXMD            ; entry point for DLL Manager c routines
        move.l  4(sp),a0        ; get address of DLLEntry structure
        moveq   #err.nimp,d0    ; Not Implemented - version not recognized
version equ     thingname+2+12
        cmp.l   #'1.00',version(a0)
        bne.s   oops
; the user area should have the shape
; MODLink:      jmp.l |code|
        lea     cod_LINK(pc),a1 ; address of routine to link
        move.l  usercode(a0),a0 ; place for usercode
        move.w  #$4ef9,(a0)+    ; opcode for jmp.l
        move.l  a1,(a0)+        ; address of routine
        moveq   #0,d0           ; no error
oops    rts
;
        end
