#ifndef _SYSLIB_HOT_H
#define _SYSLIB_HOT_H

/*
	Standard header file for PROGS SMS C library

	Hotkey System handling library

	(c) PROGS, Professional & Graphical Software
	written by Joachim Van der Auwera, 23 October 1995
*/

#include <sms.h>

#define HOT_LAST_LINE_RECALL		(HotType)-8
#define HOT_STUFF_GET_PREV			(HotType)-6
#define HOT_STUFF_GET				(HotType)-4
#define HOT_STUFF_STRING			(HotType)-2
#define HOT_COMMAND 				(HotType) 0
#define HOT_NOP 					(HotType) 2
#define HOT_EXEC_THING				(HotType) 4
#define HOT_EXEC_THING_TRANSIENT	(HotType) 5
#define HOT_EXEC_FILE				(HotType) 6
#define HOT_PICK					(HotType) 8
#define HOT_WAKE					(HotType)10
#define HOT_WAKE_TRANSIENT			(HotType)11
#define HOT_WAKE_EXEC_FILE			(HotType)12
typedef short HotType;

Error HOTStuffPut(char *line);
Error HOTStuffGet(char *line, Size length);
Error HOTStuffGetPrev(char *line, Size length);

Error HOTCreate();
Error HOTKill();

Error HOTKeyFind(char *name, Size maxlen, char *retname, HotType *type, char *key, short *active);
Error HOTKeySet(char *name, char key, HotType type, Error (*pre)());
Error HOTKeyReset(char *name, char key);
Error HOTKeyOn(char *name);
Error HOTKeyOff(char *name);
Error HOTKeyRemove(char *name);
Error HOTKeyDo(char *name);

#endif _SYSLIB_HOT_H
