/*	Standard library file for PROGS SMS C library */

/* calculates full four quadrant value of atan(y/x) for */
/* two numbers y and x, atan in range -pi <= atan < pi */

#include "math_h"

#define EPSLN 1.0E-8	/* convergence test value */

double atan2(double y, double x)
{
	double ans,arg;
  
	if ((x == 0.0) && (y == 0.0))
		return (0.0);
	arg = fabs(y)/fabs(x);
	ans = atan(arg);
	if (x < 0.0)
		ans = M_PI - ans;
	if (y < 0.0)
		ans = -ans;
	return (ans);
}
