/*
	test program for PROGS SMS C library

	test for atomic library

	written by Joachim Van der Auwera for PROGS
	(c) 1994 by PROGS, Professional & Graphical Software
*/

#include "atomic_h"
#include "io_h"
#include "str_h"
#include "rout_h"
#include "net_h"
#include "mutex_h"

#define tell(x) IOPutString(chid,x,&sent)
#define value(s,x) { STRFormatPutSafe(line,80,"%s : %d",s,x); tell(line); }

Error atomic1(int parm) { return parm; }
Error atomic2() { return ATOMICNow(); }

int params[2]={1,234};

void init()
{
	Error err;
	Channel chid;
	int sent, i, r;
	char line[80], chr;
	NetNode net;
	MutexHandler mutex; char mutexchar;

	err=IOOpen("con",OPEN_OVER,&chid);

	value("test ATOMICNow in direct call",atomic2());
	value("test param passing and error return",ATOMICCall(atomic1,1,123));
	value("test ATOMICNow in ATOMICCall",ATOMICCall(atomic2,0));

	value("test ROUTCall",ROUTCall(atomic1,1,123));
	value("test ROUTCallList",ROUTCallList(atomic1,params));

	NETNodeGet(&net);
	value("current network node",net);
	NETNodeSet(net+1);
	tell("network node number incremented");

	mutex.MutexRelease=NULL;
	mutex.mutex=&mutexchar;
	value("test param passing and error return on MUTEX",MUTEXCall(&mutex,atomic1,1,123));
	value("test ATOMICNow in MUTEXCall",MUTEXCall(&mutex,atomic2,0));

	tell ("press a key");
	IOGet(chid,&chr);
	IOClose(chid);
}
