/*
	test program for PROGS SMS C library

	program to increase the dataspace for a file by 4k to accomodate the stack

	written by Joachim Van der Auwera for PROGS
	(c) 1994 by PROGS, Professional & Graphical Software
*/

#include "sms_h"
#include "io_h"
#include "str_h"

#define tell(x) IOPutString(chid,x,&sent)
#define put(ch,x) IOPutString(ch,x,&sent)

void report(char *oops)
{
	Error err;
	Channel chid;
	int sent; char chr;

	IOOpen("con",OPEN_OVER,&chid);
	tell(oops);
	tell("press a key");
	IOGet(chid,&chr);
	IOClose(chid);
}

Error init(char *name)
{
	Error err;
	Channel in;
	char line[80];
	Size space;

	err=IOOpenPath(name,OPEN_OLD,PATH_DATA,&in);
	if (err)
	{
		STRFormatPutSafe(line,80,"can't open file %s",line);
		report(line);
		return err;
	}
	err=IODataSpaceGet(in,&space);
	if (err) { report("can't get dataspace value of file"); return err; }
	err=IODataSpaceSet(in,space+4096);
	if (err) { report("can't set dataspace value of file"); return err; }
	IOClose(in);
	return ERR_OK;
}
