/*
	test program for PROGS SMS C library
	test for io library
	written by Joachim Van der Auwera for PROGS
	(c) 1994 by PROGS, Professional & Graphical Software
*/

#include "sms_h"
#include "mem_h"
#include "io_h"
#include "stdio_h"
#include "qdos_h"

void main()
{
	Error err;
	int pos,good,total; TimeOut t;
	Channel chid;
	char line[80],chr;

	/* test IOOpen, IOClose and IOOpenFor */

	err=IOOpen("scr_240x200a100x100",OPEN_OLD,&chid);
	printf("open channel %x, with error %d",chid,err); gets(line);
	err=IOClose(chid);
	printf("channel closed, with error %d",err); gets(line);

	err=IOOpenFor("scr_240x200a100x100",OPEN_OLD,SYSTEM,&chid);
	printf("open channel %x, with error %d",chid,err); gets(line);
	err=IOClose(chid);
	printf("channel closed, with error %d",err); gets(line);

	/* see if IOPut works, by opening new file on ramdisk, and writing to it */

	err=IOOpen("ram1_testfile",OPEN_NEW,&chid);
	printf("opened file %x, with error %d",chid,err); gets(line);
	err=IOPut(chid,'P'); printf("P %d ",err);
	err=IOPut(chid,'R'); printf("R %d ",err);
	err=IOPut(chid,'O'); printf("O %d ",err);
	err=IOPut(chid,'G'); printf("G %d ",err);
	err=IOPut(chid,'S'); printf("S %d ",err);
	IOClose(chid); printf("closed"); gets(line);

	/* see if reading the file works */

	err=IOOpen("ram1_testfile",OPEN_OLD,&chid);
	printf("opened file %x, with error %d",chid,err); gets(line);
	err=IOGet(chid,&chr); printf("%c %d ",chr,err);
	err=IOGet(chid,&chr); printf("%c %d ",chr,err);
	err=IOGet(chid,&chr); printf("%c %d ",chr,err);
	err=IOGet(chid,&chr); printf("%c %d ",chr,err);
	err=IOGet(chid,&chr); printf("%c %d\n",chr,err);

	err=IOPositionGet(chid,&pos);
	IOTimeOutGet(chid,&t);
	printf("timeout %d, position %d %d\n",t,pos,err);
	err=IOTimeOutSet(chid,NOWAIT);
	IOTimeOutGet(chid,&t);
	printf("changed timout to %d (0), err %d\n",t,err);
	err=IOTimeOutSet(chid,FOREVER);
	IOPositionSet(chid,3);
	err=IOGet(chid,&chr); printf("pos 'G' %c %d ",chr,err);
	IOPositionMove(chid,-2);
	err=IOGet(chid,&chr); printf("pos 'O' %c %d\n",chr,err);
	err=IOPositionMove(chid,TO_END_OF_FILE);
	IOPositionGet(chid,&pos);
	printf("moved to end err %d, pos %d, test %d, done %d",err,pos,IOTest(chid),IODone(chid));

	err=IOPutString(chid, "\nadd a line",&pos);
	printf("line added %d %d chars (11+1)\n",err,pos);

	IOClose(chid); printf("closed"); gets(line);

	err=IODelete("ram1_testfile");
	printf("ram file deleted %d",err); gets(line);

	printf("type device to format"); gets(line);
	err=IOFormat(line,&good,&total);
	printf("formatted %s to %d/%d, err %d\n",line,good,total,err);

}
