/*
	test program for PROGS SMS C library
	test for io library
	written by Joachim Van der Auwera for PROGS
	(c) 1994 by PROGS, Professional & Graphical Software
*/

#include "sms_h"
#include "io_h"
#include "str_h"

#define tell(x) IOPutString(chid,x,&sent)

#define error(x) { char line[80]; \
				   STRFormatPutSafe(line,80,"%s ; %d", x, err); \
				   tell(line); }

void init()
{
	Error err;
	Channel chid, file;
	int sent;
	Size len; FileVersion ver; FileType typ; MediumInfo mdi; Time tim;
	char line[80], path[80], chr;

	err=IOOpen("con",OPEN_OVER,&chid);

	/* IOMakeDirectory */
	tell("give name of directory to create");
	err=IOGetString(chid, line, 20); tell(line);
	if (err) error("error on IOGetString of 20 chars");
	err=IOMakeDirectory(line);
	error("directory created");

	/* IOOpenPath, IOName, IOLength, version, type, dataspace get */
	tell("give path to search on");
	IOGetString(chid,path,80); tell(path);
	tell("give filename");
	IOGetString(chid,line,80); tell(line);
	err=IOOpenPath(line,OPEN_READ,path,&file);
	error("path opened");
	err=IOName(file,line,path);
	error("IOName");
	tell(path); tell(line);
	err=IOLength(file, &len);
	STRFormatPutSafe(line,80,"IOLength error %d, length %d",err,len); tell(line);
	err=IOVersionGet(file, &ver);
	STRFormatPutSafe(line,80,"IOVersionGet error %d, version %d",err,ver); tell(line);
	err=IOFileTypeGet(file, &typ);
	STRFormatPutSafe(line,80,"IOFileTypeGet error %d, type %d",err,typ); tell(line);
	err=IODataSpaceGet(file, &len);
	STRFormatPutSafe(line,80,"IODataSpaceGet error %d, dataspace %d",err,len); tell(line);
	err=IOMedium(file,&mdi);
	error("Medium info");
	STRFormatPutSafe(line,80,"dev %s, name %s, rdo %d, size %d, %d/%d",
		mdi.devicename, mdi.mediumname, mdi.readonly, mdi.unitsize,
		mdi.mediumfree, mdi.mediumsize); tell(line);
	err=IOUpdateTimeGet(file, &tim);
	STRFormatPutSafe(line,80,"IOUpdateTimeGet error %d",err); tell(line);
	STRTime(tim,line); tell(line);
	STRDay(tim,line); tell(line);
	err=IOBackupTimeGet(file, &tim);
	STRFormatPutSafe(line,80,"IOBackupTimeGet error %d",err); tell(line);
	STRTime(tim,line); tell(line);
	STRDay(tim,line); tell(line);

	tell ("press a key");
	IOGet(chid,&chr);
	IOClose(chid);
}
