/*
	test program for PROGS SMS C library
	test for MEM library
	written by Joachim Van der Auwera for PROGS
	(c) 1994 by PROGS, Professional & Graphical Software
*/

#include "mem.h"
#include "stdio.h"
#include "qdos.h"

char *keep=0x12345678;

void ZapRoutine(void *base)
{
	keep=base;
	SMSBeep(2000,20);
}

void main()
{
	void *base,*base2;
	int length=100*1024;
	char line[80]; int mf, ml; Error err;

	MEMFree(&mf); MEMLargest(&ml);
	printf("MEMFree %d, MEMLargest %d\n", mf, ml);

	err=MEMAllocate(length,&base);
	puts("allocated 100k for my job");
	gets(line);
	err=MEMAllocateFor(length,SYSTEM,&base2);
	puts("allocated 100k for the system");
	gets(line);
	MEMRelease(base);
	puts("released 100k, owned by myself");
	gets(line);
	MEMRelease(base2);
	puts("released 100k, owned by the system");
	gets(line);

	_super();
	MEMAllocate(length,&base);
	_user();
	MEMWhenZapped(base,&ZapRoutine,NULL);
	printf("allocated, ZapRoutine set, %d ",base); gets(line);
	_super();
	MEMRelease(base);
	_user();
	printf("global %d ",keep);	keep=0x12345678;

	MEMAllocate(length,&base);
	MEMWhenZapped(base,NULL,(char *)&keep);
	printf("allocated, ZapAddress set, %x, at %x ",keep,&keep); gets(line);
	MEMRelease(base);
	printf("global %x ",keep);	keep=0x12345678;

	MEMAllocate(length,&base);
	MEMWhenZapped(base,&ZapRoutine,(char *)&keep);
	printf("allocated, both set, %x %x",keep,base); gets(line);
	MEMRelease(base);
	printf("global %x ",keep);
}
