/*
	test program for PROGS SMS C library
	test for thing library
	written by Joachim Van der Auwera for PROGS
	(c) 1994 by PROGS, Professional & Graphical Software
*/

#include "win_h"
#include "str_h"
#include "thing_h"

WindowDescriptor window={300,100,50,50, 6,6, 2,2, 7,0};

Window chid;

Error test1()
{
	WINPutString(chid,"thing routine test1 executed");
}

Error test2(Window win,char *str)
{
	WINPutString(win,str);
}

#define TEST1_NAME 0x54535431
#define TEST2_NAME 0x54535432
#define THING_VERSION 4874

ThingExtension thg_list[]={{TEST1_NAME,test1},{TEST2_NAME,test2},NULL};
ThingDefinition thg_defn={"THINGCreate test",THING_VERSION,FALSE,
						  NULL,NULL,NULL,NULL,thg_list};

void init()
{
	Error err;
	char chr;
	char line[80];
	Thing thg;
	int vers;

	err=WINOpenFull(&window,&chid);

	WINPutString(chid,"start of thing test");
	THINGCreate(&thg_defn);
	WINPutString(chid,"thing created - press a key");
	WINGet(chid,line);

	THINGCall("THINGCreate test",TEST1_NAME,0);
	THINGCall("THINGCreate test",TEST2_NAME,2,chid,"test2 also works");

	THINGUse("THINGCreate test",NULL,&thg,&vers);
	if (vers!=THING_VERSION) WINPutString(chid,"version not correct");
	WINPutString(chid,"thing now in use - press a key");
	WINGet(chid,line);

	THINGCallIn(thg,TEST1_NAME,0);
	THINGCallIn(thg,TEST2_NAME,2,chid,"test2 also works");

	THINGFree("THINGCreate test");
	WINPutString(chid,"thing freed - press a key");
	WINGet(chid,line);


	THINGRemove("THINGCreate test");
	WINPutString(chid,"thing removed - press a key");
	WINGet(chid,line);

	WINPutString(chid,"press a key");
	WINGet(chid,&chr);
	WINClose(chid);
}
